#include <iostream>
#include <algorithm>
#include <vector>
#include "Sequence.h"
#include "Polygon.h"

using namespace std;

void Guy(vector<int>& v, int n) {
    if(std::find(v.begin(), v.end(), n) != v.end()) return;
    v.push_back(n);
    if(n%2==0) {cout<<n<<" "; cin.get(); Guy(v, 3*n/2); } //cin.clear(); }
    else if(n%4==1) {cout<<n<<" "; Guy(v, (3*n+1)/4);}
    else {cout<<n<<" "; Guy(v, (3*n-1)/4);}
}

void Collatz(int n) {
    cout << n << ' ';
    if(n == 1) return ;
    else if(n%2==0) Collatz(n/2);
    else Collatz(3*n+1);
}

int main()
{
    //typedef vector<int> IntContainer;
    //IntContainer v;
    vector<int> v;
    //typedef IntContainer::iterator IntIterator;
    //IntIterator i = v.begin();
    int n;
//    cout << "Enter an initial value for the Cottatz sequence:" << endl;
//    cin >> n;
//    Collatz(n);
//    cout << "Enter an initial value for the Guy sequence:" << endl;
//    cin >> n;
//    Guy(v,n);
//    cout << "\nThe list has " << v.size() << " elements:\n";
//    for(auto i=v.begin(); i!=v.end(); cout << *i++ << " ");
    // After declaring nextValue() to be virtual, by writing nextValue() = 0
    // the following for-loop won't work because a Sequence cannot be instantiated.
    /*for(long a=1;a<6;a++) {
        cout<<"s("<<a<<") = ";
        Sequence s(a);
        s.printSequence(a);
        cout << endl;
    }*/
    for(long a=1;a<6;a++) {
        cout<<"as("<<a<<") = ";
        ArithSequence as(a);
        as.printSequence(a);
        cout << endl;
    }
    for(long a=1;a<6;a++) {
        cout<<"gs("<<a<<") = ";
        GeomSequence gs(a);
        gs.printSequence(a);
        cout << endl;
    }
    cout << "\nThe Lucas sequence is Fibonacci like in that the same recursive formula\n"
         << "governs its behavior.  The first two terms are L0 = 2 and L1 = 1:\n";
    FibonacciSequence fs(2,1);
    fs.printSequence(20);
    cout << endl << endl;
    for(long a=1;a<6;a++) {
        for(long b=a+1;b<7;b++) {
            cout<<"fs("<<a<<", "<<b<<") = ";
            FibonacciSequence fs(b,a);
            fs.printSequence(18);
            cout << endl;
        }
        cout << endl;
    }
    // Polygon stuff
    Point2D A(0.,0.), B(0.,1.), C(1.,0.), D(1.,1.);
	Triangle triangle1(A,B,C);
    Triangle triangle2(A,B,D);

	//Polygon* ptr_polygon = &triangle1;
	//Polygon* ptr_polygon2 = &triangle2;

    cout << "\nThe area of triangle1 is " << triangle1.area();
    cout << "\nThe area of triangle2 is " << triangle2.area();

    return 0;
}
